package emailmessage;


import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Map;

import com.primeton.esb.message.ITipMessagePayload;
import com.primeton.esb.message.TipMessageBuilder;

public class EmailConvert {
	/*
	* 根据 Email 请求消息构建 SOAP 消息
	*/
	public ITipMessagePayload email_ws(ITipMessagePayload inMessage) {
		Map protocolHeaders = new HashMap();
		protocolHeaders.put("$tip_method", "POST");
		protocolHeaders.put("Host", "127.0.0.1:9091");
		protocolHeaders.put("Content-Length", "242");
		protocolHeaders.put("User-Agent", "Apache-HttpClient/4.1.1 (java 1.5)");
		 // 本示例调用 wsdemo.war 中 WS ，其访问地址为：http://127.0.0.1:8088/wsdemo/services/CustMgrService?wsdl
		 //Connection 为 WS 业务服务中导入 WSDL 后显示的 URI
		 //SOAPAction 为要调用的操作
		protocolHeaders.put("Connection", "/wsdemo/services/CustMgrService");
		protocolHeaders.put("remote.addr", "127.0.0.1:8080");
		protocolHeaders.put("SOAPAction", "addCust");
		protocolHeaders.put("Accept-Encoding", "gzip,deflate");
		protocolHeaders.put("$tip_protocol", "HTTP/1.1");
		protocolHeaders.put("Content-Type", "text/xml*/");
		protocolHeaders.put("$tip_consumer.message.req.encoding", "UTF-8");
		protocolHeaders.put("$tip_consumer.message.resp.encoding", "UTF-8");
		inMessage.getSystemHeaders().put("$tip_message_encoding", "UTF-8");
		inMessage.getSystemHeaders().put("$tip_message_invoke_type",Integer.valueOf(3));
		TipMessageBuilder msgBuilder = TipMessageBuilder.withPayload(new String((byte[]) inMessage.getMessagePayload()));
		msgBuilder.setMessageHeaders(inMessage.getMessageHeaders());
		msgBuilder.setProtocolHeaders(protocolHeaders);
		inMessage.getSystemHeaders().put("$tip_message_invoke_type",Integer.valueOf(3));
		msgBuilder.copySystemHeaders(inMessage.getSystemHeaders());
		return msgBuilder.build();
	}

	/*
	* 根据 SOAP 消息构建 Email 消息
	*/
	public ITipMessagePayload ws_email(ITipMessagePayload inMessage) throws	UnsupportedEncodingException {
		Map protocolHeaders = new HashMap();
		protocolHeaders.put("bcc", "");
		protocolHeaders.put("cc", "");
		protocolHeaders.put("subject", "测试 Email");
		protocolHeaders.put("mimetype", "");
		protocolHeaders.put("emailCharset", " UTF-8");
		inMessage.getSystemHeaders().put("$tip_message_invoke_type",Integer.valueOf(2));
		TipMessageBuilder msgBuilder = null;
		System.out.println(new String((byte[])inMessage.getMessagePayload(),"UTF-8"));
		if ((inMessage.getMessagePayload() instanceof byte[]))
			msgBuilder = TipMessageBuilder.withPayload((byte[]) inMessage.getMessagePayload());
		else
			msgBuilder =TipMessageBuilder.withPayload(((String)inMessage.getMessagePayload()).getBytes());
		msgBuilder.setMessageHeaders(inMessage.getMessageHeaders());
		msgBuilder.setProtocolHeaders(protocolHeaders);
		msgBuilder.copySystemHeaders(inMessage.getSystemHeaders());
		inMessage.getSystemHeaders().put("$tip_message_invoke_type",
		Integer.valueOf(2));
		return msgBuilder.build();
	}
}
